#include "../calypso_api_i.h"

#ifndef CALYPSO_NO_DATETIME

BOOL CalypsoDate14ToTimestamp(_DATETIME_ST *dst, WORD src)
{
  if (dst == NULL) return FALSE;
  
  dst->_time.hour   = 0;
  dst->_time.minute = 0;
  dst->_time.second = 0;
  
  /* 01/01/1997 */
  dst->_date.day    = 1;
  dst->_date.month  = 1;
  dst->_date.year   = 1997;
  
  /* increment */
  while (src--)
    datetime_next_day(dst);    
  
  return is_date_valid(dst);
}

WORD CalypsoTimestampToDate14(const _DATETIME_ST *src)
{
  _DATETIME_ST timestamp;
  register WORD value = 0;
  
  if (src == NULL) goto done;

  memcpy(&timestamp, src, sizeof(_DATETIME_ST));
  timestamp._time.hour   = 0;
  timestamp._time.minute = 0;
  timestamp._time.second = 0;

  if (!is_date_valid(&timestamp)) goto done;
  
  if (timestamp._date.year < 1997) goto done;
  
  while ((timestamp._date.year  != 1997)
      || (timestamp._date.month != 1)
      || (timestamp._date.day   != 1))
  {
    datetime_prev_day(&timestamp);
    value++;
  }
  
done:
  return value;  
}

BOOL CalypsoTime11ToTimestamp(_DATETIME_ST *dst, WORD src)
{
  if (dst == NULL) return FALSE;

  dst->_time.hour   = (BYTE) (src / 60);
  dst->_time.minute = (BYTE) (src % 60);
  dst->_time.second = 0;
  
  return TRUE;
}

WORD CalypsoTimestampToTime11(const _DATETIME_ST *src)
{
  WORD value = 0;
  
  if (src == NULL) goto done;

  value  = src->_time.hour;
  value *= 60;
  value += src->_time.minute;

done:
  return value;
}

BOOL CalypsoDate14IsBefore(const _DATETIME_ST *now, WORD value)
{
  _DATETIME_ST chk, _now;

  if (now == NULL)
  {
    get_datetime(&_now);
    now = &_now;
  }
  
  CalypsoDate14ToTimestamp(&chk, value);
 
  if (chk._date.year  > now->_date.year) return TRUE;
  if ((chk._date.year == now->_date.year) && (chk._date.month > now->_date.month)) return TRUE;
  if ((chk._date.year == now->_date.year) && (chk._date.month == now->_date.month) && (chk._date.day >= now->_date.day)) return TRUE;

  return FALSE;
}

BOOL CalypsoDate14IsAfter(const _DATETIME_ST *now, WORD value)
{
  _DATETIME_ST chk, _now;

  if (now == NULL)
  {
    get_datetime(&_now);
    now = &_now;
  }

  CalypsoDate14ToTimestamp(&chk, value);
 
  if (chk._date.year  < now->_date.year) return TRUE;
  if ((chk._date.year == now->_date.year) && (chk._date.month < now->_date.month)) return TRUE;
  if ((chk._date.year == now->_date.year) && (chk._date.month == now->_date.month) && (chk._date.day <= now->_date.day)) return TRUE;

  return FALSE;
}

#endif
