/**h* MifUlCAPI/Legacy
 *
 * NAME
 *   MifUlCAPI :: Specific entry points for Legacy re-entrant and non-reentrant DLL
 *
 * COPYRIGHT
 *   (c) 2009 SpringCard - www.springcard.com
 *
 * SEE ALSO
 *   LegacyEX
 *
 **/

#include "sprox_mifulc_i.h"

#ifndef _USE_PCSC

SPROX_RC MifUlC_Command(SPROX_PARAM  const BYTE send_buffer[], WORD send_length, BYTE recv_buffer[], WORD *recv_length)
{
  SWORD rc;

#if (SPROX_INS_LIB_TRACE)
  if (trace_level & TRACE_LEVEL_USER_1)
  {
    TRACE_S(TRACE_MICORE, "MifUlC<");
    trace_h(send_buffer, send_length, FALSE);
    TRACE_CRLF(TRACE_MICORE);
  }
#endif

  send_length += 2;

  rc = SPROX_API_CALL(A_Exchange) (SPROX_PARAM_P  send_buffer, send_length, recv_buffer, recv_length, TRUE, 1024);

  if ((rc == MI_OK) && (recv_length != NULL))
  {
#if (SPROX_INS_LIB_TRACE)
    if (trace_level & TRACE_LEVEL_USER_1)
    {
      TRACE_S(TRACE_MICORE, "MifUlC>");
      trace_h(recv_buffer, *recv_length, FALSE);
      TRACE_CRLF(TRACE_MICORE);
    }
#endif

    if (*recv_length >= 2)
      *recv_length -= 2;
    else
     rc = MI_BYTECOUNTERR;
  }

  return rc;
}

#endif
