/*
  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.

  Copyright (c) 2003-2010 PRO ACTIVE SAS - www.proactive-group.com
   
  Ref_DesFire_EV1.c
  -----------------

  This is the reference applications that validates the ISO 7816 part
  of the SpringProx API for NXP DESFire EV1 cards.
  
  JDA 24/09/2010 : initial release

*/
#include "products/springprox/springprox.h"
#include "cardware/desfire/sprox_desfire.h"

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef __linux__
#include <sys/time.h>
#endif


#include "products/springprox/springprox.h"
#include "cardware/desfire/sprox_desfire.h"

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef __linux__
#include <sys/time.h>
#endif

//#define LOOP_TEST

#ifdef WIN32
#define CHECK_RC() { if (rc!=0)      { printf("\nline %d - failed (%d) %s\n", __LINE__-1, rc, SPROX_Desfire_GetErrorMessage(rc)); goto tag_halt; } printf("."); fflush(NULL); }
#endif

#ifdef __linux__
#define CHECK_RC() { if (rc!=0)      { printf("\nline %d - failed (%d) %s\n", __LINE__-1, rc, SPROX_Desfire_GetErrorMessage(rc)); goto tag_halt; } printf("."); fflush(NULL); }
#endif

const BYTE abNullKey[24]      = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const BYTE abRootKey1[24]     = { "ABCDEFGHABCDEFGHABCDEFGH" };
const BYTE abRootKey2[24]     = { "Card Master Key!Card Mas" };

const char Appli1Name[]   = "Iso Appli 1";
const char Appli2Name[]   = "Iso Appli 2";
const char Appli3Name[]   = "Iso Appli 3";
const char Appli4Name[]   = "Iso Appli 4";

const char Appli1Fci[]    = "FCI of Iso Appli 1";
const char Appli2Fci[]    = "FCI of Iso Appli 2";
const char Appli3Fci[]    = "FCI of Iso Appli 3";
const char Appli4Fci[]    = "FCI of Iso Appli 4";

const BYTE Appli2Key1[16] = { 0 }; // { "TripleDES Key #1" };
const BYTE Appli2Key2[16] = { 0 }; // { "TripleDES Key #2" };

const BYTE Appli3Key1[24] = { 0 }; // { "TripleDES Key #1        " };
const BYTE Appli3Key2[24] = { 0 }; // { "TripleDES Key #2        " };

const BYTE Appli4Key1[16] = { 0 }; // { "AES Key #1      " };
const BYTE Appli4Key2[16] = { 0 }; // { "AES Key #2      " };

const BYTE appCKey1[24]   = { 0 }; // { "App.C Key #1.   App.C Ke" };
const BYTE appCKey2[24]   = { 0 }; // { "App.C Key #2..  App.C Ke" };
const BYTE appCKey3[24]   = { 0 }; // { "App.C Key #3... App.C Ke" };
const BYTE appCKey4[24]   = { 0 }; // { "App.C Key #4....App.C Ke" };

const WORD Appli1File1Sz    = 1536;
const WORD AppliXFile1Sz    = 1024;
const BYTE AppliXFile2Sz    = 64;
const BYTE AppliXFileXRecSz = 20;
const BYTE AppliXFileXRecCo = 7;

const BYTE WriteSz            = 55;

/* Budrate in each direction */
BYTE want_dsi_dri = 0;

BOOL ISOSELFTEST(void);

int main(int argc, char **argv)
{
  SWORD rc;
	WORD sw;
  int i, j;
  char s_buffer[64];

  BYTE atq[2];
  BYTE sak[1];
  BYTE snr[12];
  BYTE snrlen = 12;
  BYTE ats[32];
  BYTE atslen = 32;

  BYTE card_identifier  = 0xFF;  /* Default 0xFF means 'no CID' */
	BYTE want_dsi_dri     = 0;
	BOOL verbose = FALSE;

  char *device = NULL;

  printf("SpringCard SDK for K531/SpringProx-CF/CSB Legacy\n");
  printf("\n");
  printf("NXP DESFIRE ISO reference demo (DES/3DES2K/3DES3K/AES)\n");
  printf("------------------------------------------------------\n");
  printf("www.springcard.com\n\n");

  for (i=1; i<argc; i++)
  {
    if (!strcmp(argv[i], "-b0"))
		{
		  want_dsi_dri = 0;
		} else
    if (!strcmp(argv[i], "-b1"))
		{
		  want_dsi_dri = 1;
		} else
    if (!strcmp(argv[i], "-b2"))
		{
		  want_dsi_dri = 2;
		} else
    if (!strcmp(argv[i], "-b3"))
		{
		  want_dsi_dri = 3;
		} else
    if (!strcmp(argv[i], "-uc"))
		{
		  card_identifier = 1;
		} else
    if (i == argc-1)
    {
      device = argv[i];
      printf("Device : '%s'\n", device);
    } else
    {
      printf("usage: ref_desfire_iso [-v] [-b0|-b1|-b2|-b3] [-uc] [device]\n");
			printf("       -v  : verbose mode\n");
      printf("       -b0 : set baudrate to 106kbit/s\n");
      printf("       -b1 : set baudrate to 212kbit/s\n");
      printf("       -b2 : set baudrate to 424kbit/s\n");
      printf("       -b3 : set baudrate to 848kbit/s\n");
			printf("       -uc : use a card identifier (CID)\n");
      printf("\n");
      return 0;
    }
  }

  rc = SPROX_GetLibrary(s_buffer, sizeof(s_buffer));
  if (rc != MI_OK)
  {
    printf("Failed to get API version\n");
    goto done;
  }
  printf("API version : %s\n", s_buffer);
  printf("\n");


  SPROX_Desfire_SelectCid(card_identifier);

  /* Open reader */
  /* ----------- */

  rc = SPROX_ReaderOpen(device);
  if (rc != MI_OK)
  {
    printf("Reader not found\n");
    goto done;
  }

  rc = SPROX_ReaderGetDevice(s_buffer, sizeof(s_buffer));
  if (rc == MI_OK)
    printf("Reader found on %s\n", s_buffer);

  rc = SPROX_ReaderGetFirmware(s_buffer, sizeof(s_buffer));
  if (rc == MI_OK)
    printf("Reader firwmare is %s\n", s_buffer);

  /* Configure reader in ISO 14443-A mode */
  /* ------------------------------------ */
  rc = SPROX_SetConfig(CFG_MODE_ISO_14443_A);
  if (rc != MI_OK)
  {
    printf("Failed to configure the reader\n");
    goto close;
  }

  /* RF field ON */
  SPROX_ControlRF(TRUE);

  /* Select any tag in the ISO 14443-A RF field */
  /* ------------------------------------------ */
next_tag:

  printf("Waiting for a tag...\n");

  rc = SPROX_TclA_ActivateIdle(atq, snr, &snrlen, sak);
  if (rc == MI_CARD_NOT_TCL)
  {
    /* On a bien trouve un badge, mais il s'arrete au type 3 */
    printf("The selected tag is not ISO 14443-4 (T=CL)\n");
    goto tag_halt;
  }
  if (rc == MI_NOTAGERR)
  {
    /* Pas de badge dans le champ */
    printf("No available tag in RF field\n");
    goto close;
  }
  if (rc != MI_OK)
  {
    /* Erreur */
    printf("Failed to select tag\n");
    goto close;
  }

  printf("T=CL tag found, SNR=");
  for (i = 0; i < snrlen; i++)
    printf("%02X", snr[i]);
  printf(" ATQ=%02X%02X SAK=%02X\n", atq[1], atq[0], sak[0]);

  /* Is the tag a DESFire ? */
  /* ---------------------- */
  if ( (atq[1] != 0x03) || ( (atq[0] != 0x44) && (atq[0] != 0x04) ))
  {
    printf("This is not a DESFire tag\n");
    goto tag_halt;
  }

  /* Open a T=CL session on the tag */
  /* ------------------------------ */
  rc = SPROX_TclA_GetAts(card_identifier, ats, &atslen);
  if (rc != MI_OK)
  {
    /* Erreur */
    printf("Failed to activate the tag (%d)\n", rc);
    goto tag_halt;
  }

  printf("T=CL tag activated, ATS=");
  for (i = 0; i < atslen; i++)
    printf("%02X", ats[i]);
  printf(" (TA1=%02X TA2=%02X TA3=%02X)\n", ats[2], ats[3], ats[4]);

  /* PPS is not really interesting since we stay at 106kbps */
  rc = SPROX_TclA_Pps(card_identifier, want_dsi_dri, want_dsi_dri);
  if (rc != MI_OK)
  {
    /* Erreur */
    printf("Failed to negociate PPS (DSI=DRI=%d)\n", want_dsi_dri);
    goto tag_stop;
  }
  printf("PPS OK, DSI=DRI=%d\n", want_dsi_dri);

  /* Check DESFire library functions */
  /* ------------------------------- */


  {

		SWORD rc;
		DWORD dwFreeBytes = 4096;
		BYTE bNApplicationsFound;
		DF_ISO_APPLICATION_ST astIsoApplications[32];
		BYTE abDataBuffer[8192];
		WORD wDataLength;
		WORD wOffset;
		BYTE bRecNo;
		BYTE abFci[280];
		WORD wFciLength;
		WORD wDesFireSoftwareVersion;
		BYTE bLe;
		BOOL trace = FALSE;
		BOOL beep  = TRUE;
		int i;
	
		DF_VERSION_INFO stVersionInfo;

		rc = SPROX_Desfire_IsoSelectApplet(&sw);
		CHECK_RC();

		//  After activating a DesFire card the currently selected 'application' is the card
		//  level (AID = 0). Therefore the next command is redundant.
		//  We use the command to check that the card is responding correctly.
		rc = SPROX_Desfire_SelectApplication(0);
		CHECK_RC();

	
		//  Get the card's version information.
		rc = SPROX_Desfire_GetVersion(&stVersionInfo);
		CHECK_RC();
		wDesFireSoftwareVersion =
		  (unsigned int) ((unsigned int) stVersionInfo.
		                  bSwMajorVersion << 8 | stVersionInfo.bSwMinorVersion);
	
    if (wDesFireSoftwareVersion < 0x0100)
    {
      printf("\nThis is a Desfire EV0 - ISO functions are NOT supported!\n");			
      goto tag_stop;
    }

	  rc = SPROX_Desfire_Authenticate(0, abNullKey);
		CHECK_RC();
	
		// Get the UID of the card
		rc = SPROX_Desfire_GetCardUID(abDataBuffer);
		CHECK_RC();
      	
		//  At this point we would like to begin with a blank card.
		rc = SPROX_Desfire_FormatPICC();
		CHECK_RC();
	
	  rc = SPROX_Desfire_GetFreeMemory(&dwFreeBytes);
	  CHECK_RC();

		//  Create 5 applications:

		rc = SPROX_Desfire_CreateApplication(0xFF0000, 0xFF, 0);
		CHECK_RC();
	
    rc = SPROX_Desfire_CreateIsoApplication(0xFF0001, 0xFF, DF_APPLSETTING2_ISO_EF_IDS, 0x0001, Appli1Name, (BYTE) strlen(Appli1Name));
		CHECK_RC();

    rc = SPROX_Desfire_CreateIsoApplication(0xFF0002, 0x0F, DF_APPLSETTING2_ISO_EF_IDS | 3, 0x0002, Appli2Name, (BYTE) strlen(Appli2Name));
		CHECK_RC();

    rc = SPROX_Desfire_CreateIsoApplication(0xFF0003, 0x0F, DF_APPLSETTING2_ISO_EF_IDS | DF_APPLSETTING2_3DES3K | 3, 0x0003, Appli3Name, (BYTE) strlen(Appli3Name));
		CHECK_RC();

    rc = SPROX_Desfire_CreateIsoApplication(0xFF0004, 0x0F, DF_APPLSETTING2_ISO_EF_IDS | DF_APPLSETTING2_AES | 3, 0x0004, Appli4Name, (BYTE) strlen(Appli4Name));
		CHECK_RC();

		//  Verify that we list only 4 ISO applications
		rc = SPROX_Desfire_GetIsoApplications(32, astIsoApplications, &bNApplicationsFound);
    CHECK_RC();

		if (verbose)
		{
			printf("\n");
			printf("%d ISO application(s) found:\n", bNApplicationsFound);
			for (i=0; i<bNApplicationsFound; i++)
			{
				printf("- %06lX = ISO %04X  ", astIsoApplications[i].dwAid, astIsoApplications[i].wIsoId);
				for (j=0; j<astIsoApplications[i].bIsoNameLen; j++)
					printf("%02X", astIsoApplications[i].abIsoName[j]);
				for (   ; j<16; j++)
					printf("  ");
				printf("  ");
				for (j=0; j<astIsoApplications[i].bIsoNameLen; j++)
					printf("%c", (astIsoApplications[i].abIsoName[j] >= ' ') ? astIsoApplications[i].abIsoName[j] : '.');
				printf("\n");
			}
		}

		//  Create an FCI file (ID=31) in ISO applications
		//  ----------------------------------------------

		//  application 1

		rc = SPROX_Desfire_SelectApplication(0);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli1Name, (BYTE) strlen(Appli1Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(31, 0xF000, DF_COMM_MODE_PLAIN, 0xEEEE, strlen(Appli1Fci));
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0xF000, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoUpdateBinary(0, Appli1Fci, (BYTE) strlen(Appli1Fci), &sw);
    CHECK_RC();

		rc = SPROX_Desfire_ChangeFileSettings(31, DF_COMM_MODE_PLAIN, 0xEFFF);
    CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 0, &wDataLength, &sw);
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli1Name, (BYTE) strlen(Appli1Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0001, abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		//  application 2

		rc = SPROX_Desfire_SelectApplication(0);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli2Name, (BYTE) strlen(Appli2Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(31, 0xF000, DF_COMM_MODE_PLAIN, 0xEEEE, (BYTE) strlen(Appli2Fci));
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0xF000, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoUpdateBinary(0, Appli2Fci, (BYTE) strlen(Appli2Fci), &sw);
    CHECK_RC();

		rc = SPROX_Desfire_ChangeFileSettings(31, DF_COMM_MODE_PLAIN, 0xEFFF);
    CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 0, &wDataLength, &sw);
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli2Name, (BYTE) strlen(Appli2Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0002, abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		//  application 3

		rc = SPROX_Desfire_SelectApplication(0);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli3Name, (BYTE) strlen(Appli3Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(31, 0xF000, DF_COMM_MODE_PLAIN, 0xEEEE, (BYTE) strlen(Appli3Fci));
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0xF000, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoUpdateBinary(0, Appli3Fci, (BYTE) strlen(Appli3Fci), &sw);
    CHECK_RC();

		rc = SPROX_Desfire_ChangeFileSettings(31, DF_COMM_MODE_PLAIN, 0xEFFF);
    CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 0, &wDataLength, &sw);
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli3Name, (BYTE) strlen(Appli3Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0003, abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		//  application 4

		rc = SPROX_Desfire_SelectApplication(0);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli4Name, (BYTE) strlen(Appli4Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(31, 0xF000, DF_COMM_MODE_PLAIN, 0xEEEE, (BYTE) strlen(Appli4Fci));
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0xF000, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoUpdateBinary(0, Appli4Fci, (BYTE) strlen(Appli4Fci), &sw);
    CHECK_RC();

		rc = SPROX_Desfire_ChangeFileSettings(31, DF_COMM_MODE_PLAIN, 0xEFFF);
    CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 0, &wDataLength, &sw);
    CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDFName(Appli4Name, (BYTE) strlen(Appli4Name), abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0004, abFci, sizeof(abFci), &wFciLength, &sw);
		CHECK_RC();

    // Populate the applications with relevant files
		// ---------------------------------------------

		// application 1

		rc = SPROX_Desfire_SelectApplication(0xFF0001);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(1, 0x1001, DF_COMM_MODE_PLAIN, 0xEEEE, Appli1File1Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoBackupDataFile(2, 0x1002, DF_COMM_MODE_PLAIN, 0xEEEE, AppliXFile2Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoLinearRecordFile(3, 0x1003, DF_COMM_MODE_PLAIN, 0xEEEE, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoCyclicRecordFile(4, 0x1004, DF_COMM_MODE_PLAIN, 0xEEEE, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		// application 2

		rc = SPROX_Desfire_SelectApplication(0xFF0002);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(1, 0x2001, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFile1Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoBackupDataFile(2, 0x2002, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFile2Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoLinearRecordFile(3, 0x2003, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoCyclicRecordFile(4, 0x2004, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		// application 3

		rc = SPROX_Desfire_SelectApplication(0xFF0003);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(1, 0x3001, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFile1Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoBackupDataFile(2, 0x3002, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFile2Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoLinearRecordFile(3, 0x3003, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoCyclicRecordFile(4, 0x3004, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		// application 4

		rc = SPROX_Desfire_SelectApplication(0xFF0004);
		CHECK_RC();

		rc = SPROX_Desfire_CreateIsoStdDataFile(1, 0x4001, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFile1Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoBackupDataFile(2, 0x4002, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFile2Sz);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoLinearRecordFile(3, 0x4003, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();

		rc = SPROX_Desfire_CreateIsoCyclicRecordFile(4, 0x4004, DF_COMM_MODE_PLAIN, 0x21FF, AppliXFileXRecSz, AppliXFileXRecCo);
    CHECK_RC();


		//  Define the keys
		//  ---------------

		//  application 2

		rc = SPROX_Desfire_SelectApplication(0xFF0002);
		CHECK_RC();

		rc = SPROX_Desfire_Authenticate(0, abNullKey);
		CHECK_RC();

//		rc = SPROX_Desfire_ChangeKey(1, Appli2Key1, abNullKey);
		CHECK_RC();

//		rc = SPROX_Desfire_ChangeKey(2, Appli2Key2, abNullKey);
		CHECK_RC();

		//  application 3

		rc = SPROX_Desfire_SelectApplication(0xFF0003);
		CHECK_RC();

		rc = SPROX_Desfire_AuthenticateIso24(0, abNullKey);
		CHECK_RC();

//		rc = SPROX_Desfire_ChangeKey24(1, Appli3Key1, abNullKey);
		CHECK_RC();

//		rc = SPROX_Desfire_ChangeKey24(2, Appli3Key2, abNullKey);
		CHECK_RC();

		//  application 4

		rc = SPROX_Desfire_SelectApplication(0xFF0004);
		CHECK_RC();

		rc = SPROX_Desfire_AuthenticateAes(0, abNullKey);
		CHECK_RC();

//		rc = SPROX_Desfire_ChangeKeyAes(1, 0, Appli4Key1, abNullKey);
		CHECK_RC();

//		rc = SPROX_Desfire_ChangeKeyAes(2, 0, Appli4Key2, abNullKey);
		CHECK_RC();

    //   Authentication on root application (3DES2K)
		//   -------------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_CARD_MASTER_KEY, abNullKey, &sw);
		CHECK_RC();

    //   Authentication on application 2 (3DES2K)
		//   ----------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0002, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 0, abNullKey, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 1, Appli2Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

    //   Authentication on application 3 (3DES3K)
		//   ----------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0003, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 0, abNullKey, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 1, Appli3Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

    //   Authentication on application 4 (AES)
		//   -------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0004, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 0, abNullKey, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 1, Appli4Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();


    //   Read/write the files in application 1
    //   -------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0001, NULL, 0, NULL, &sw);
		CHECK_RC();

		// Read the Standard data file

		rc = SPROX_Desfire_IsoSelectEF(0x1001, &sw);
		CHECK_RC();

		wOffset = 0;
		bLe = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_BOUNDARY_ERROR))
			{
			  /* Resume after boundary error */
			  if (bLe == 0) { bLe = 255; continue; }
				if (bLe  > 1) { bLe--;     continue; }
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < Appli1File1Sz);

		wOffset = 0;
		bLe = 17;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_BOUNDARY_ERROR))
			{
			  /* Resume after boundary error */
			  if (bLe == 0) { bLe = 255; continue; }
				if (bLe  > 1) { bLe--;     continue; }
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < Appli1File1Sz);

		// Write the Standard data file
		for (wOffset=0; wOffset<sizeof(abDataBuffer); wOffset++)
		  abDataBuffer[wOffset] = (BYTE) wOffset;

		for (wOffset = 0; wOffset < Appli1File1Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < Appli1File1Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (Appli1File1Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read again
		wOffset = 0;
		bLe = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_BOUNDARY_ERROR))
			{
			  /* Resume after boundary error */
			  if (bLe == 0) { bLe = 255; continue; }
				if (bLe  > 1) { bLe--;     continue; }
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < Appli1File1Sz);

		// Backup data file

		rc = SPROX_Desfire_IsoSelectEF(0x1002, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile2Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile2Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile2Sz-wOffset), &sw);
		  CHECK_RC();
		}

	  rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, AppliXFile2Sz, &wDataLength, &sw);
		CHECK_RC();

		// Linear record file

		rc = SPROX_Desfire_IsoSelectEF(0x1003, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(0, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
    }

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

		// Cyclic record file

		rc = SPROX_Desfire_IsoSelectEF(0x1004, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < 2 * AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo-1; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(bRecNo, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
		}

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

//ready: 

    //   Read/write the files in application 2 (3DES2K)
    //   ----------------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0002, NULL, 0, NULL, &sw);
		CHECK_RC();

		// Read the Standard data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x2001, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_AuthenticateIso(2, Appli2Key2);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 9, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 9, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 10, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 11, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 64, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 128, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 252, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 253, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 254, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 255, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 0, &wDataLength, &sw);
		CHECK_RC();

		wOffset = 0;
		bLe = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_FILE_NOT_FOUND))
			{
			  /* Why does the card return DF_FILE_NOT_FOUND instead of DF_BOUNDARY_ERROR */
				/* in this case ???                                                        */
				/* Anyway, after any error the authenticated session is broken so we must  */
				/* leave the loop (and get authenticated again before the next reading)    */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

		wOffset = 0;
		bLe = 17;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_BOUNDARY_ERROR))
			{
				/* After any error the authenticated session is broken so we must leave the loop */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		// Write the Standard data file

		for (wOffset=0; wOffset<sizeof(abDataBuffer); wOffset++)
		  abDataBuffer[wOffset] = (BYTE) wOffset;

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 1, Appli2Key1, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile1Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile1Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile1Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read again

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

		wOffset = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], 0, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_FILE_NOT_FOUND))
			{
			  /* Why does the card return DF_FILE_NOT_FOUND instead of DF_BOUNDARY_ERROR */
				/* in this case ???                                                        */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		// Write the Backup data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 1, Appli2Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x2002, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile2Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile2Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile2Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read the Backup data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

	  rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, AppliXFile2Sz, &wDataLength, &sw);
		CHECK_RC();

		// Write into the Linear record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 1, Appli2Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x2003, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

    // Read the Linear record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(0, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
    }

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

		// Write Cyclic record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 1, Appli2Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x2004, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < 2 * AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

    // Read the Cyclic record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_2KDES, DF_ISO_APPLICATION_KEY | 2, Appli2Key2, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo-1; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(bRecNo, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
		}

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();


    //   Read/write the files in application 3 (3DES3K)
    //   ----------------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0003, NULL, 0, NULL, &sw);
		CHECK_RC();

		// Read the Standard data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x3001, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_AuthenticateIso24(2, Appli3Key2);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 9, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 9, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 10, &wDataLength, &sw);
		CHECK_RC();

		wOffset = 0;
		bLe = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_FILE_NOT_FOUND))
			{
			  /* Why does the card return DF_FILE_NOT_FOUND instead of DF_BOUNDARY_ERROR */
				/* in this case ???                                                        */
				/* Anyway, after any error the authenticated session is broken so we must  */
				/* leave the loop (and get authenticated again before the next reading)    */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

		wOffset = 0;
		bLe = 17;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_BOUNDARY_ERROR))
			{
				/* After any error the authenticated session is broken so we must leave the loop */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		// Write the Standard data file

		for (wOffset=0; wOffset<sizeof(abDataBuffer); wOffset++)
		  abDataBuffer[wOffset] = (BYTE) wOffset;

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 1, Appli3Key1, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile1Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile1Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile1Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read again

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

		wOffset = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], 0, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_FILE_NOT_FOUND))
			{
			  /* Why does the card return DF_FILE_NOT_FOUND instead of DF_BOUNDARY_ERROR */
				/* in this case ???                                                        */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		// Write the Backup data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 1, Appli3Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x3002, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile2Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile2Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile2Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read the Backup data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

	  rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, AppliXFile2Sz, &wDataLength, &sw);
		CHECK_RC();

		// Write into the Linear record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 1, Appli3Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x3003, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

    // Read the Linear record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(0, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
    }

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

		// Write Cyclic record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 1, Appli3Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x3004, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < 2 * AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

    // Read the Cyclic record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_3KDES, DF_ISO_APPLICATION_KEY | 2, Appli3Key2, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo-1; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(bRecNo, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
		}

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

    //   Read/write the files in application 4 (AES)
    //   -------------------------------------------

		rc = SPROX_Desfire_IsoSelectDF(0x3F00, NULL, 0, NULL, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectDF(0x0004, NULL, 0, NULL, &sw);
		CHECK_RC();

		// Read the Standard data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x4001, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_AuthenticateAes(2, Appli4Key2);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 9, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 9, &wDataLength, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, 10, &wDataLength, &sw);
		CHECK_RC();


		wOffset = 0;
		bLe = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_FILE_NOT_FOUND))
			{
			  /* Why does the card return DF_FILE_NOT_FOUND instead of DF_BOUNDARY_ERROR */
				/* in this case ???                                                        */
				/* Anyway, after any error the authenticated session is broken so we must  */
				/* leave the loop (and get authenticated again before the next reading)    */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

		wOffset = 0;
		bLe = 17;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], bLe, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_BOUNDARY_ERROR))
			{
				/* After any error the authenticated session is broken so we must leave the loop */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		// Write the Standard data file

		for (wOffset=0; wOffset<sizeof(abDataBuffer); wOffset++)
		  abDataBuffer[wOffset] = (BYTE) wOffset;

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 1, Appli4Key1, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile1Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile1Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile1Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read again

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

		wOffset = 0;
		do
		{
			rc = SPROX_Desfire_IsoReadBinary(wOffset, &abDataBuffer[wOffset], 0, &wDataLength, &sw);
			if (rc == (DFCARD_ERROR-DF_FILE_NOT_FOUND))
			{
			  /* Why does the card return DF_FILE_NOT_FOUND instead of DF_BOUNDARY_ERROR */
				/* in this case ???                                                        */
			  break;
			}
			CHECK_RC();

			wOffset += wDataLength;
    } while (wOffset < AppliXFile1Sz);

		// Write the Backup data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 1, Appli4Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x4002, &sw);
		CHECK_RC();

		for (wOffset = 0; wOffset < AppliXFile2Sz-WriteSz; wOffset += WriteSz)
		{
			rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], WriteSz, &sw);
			CHECK_RC();
    }
		if (wOffset < AppliXFile2Sz)
		{
		  rc = SPROX_Desfire_IsoUpdateBinary(wOffset, &abDataBuffer[wOffset], (BYTE) (AppliXFile2Sz-wOffset), &sw);
		  CHECK_RC();
		}

		// Read the Backup data file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

	  rc = SPROX_Desfire_IsoReadBinary(0, abDataBuffer, AppliXFile2Sz, &wDataLength, &sw);
		CHECK_RC();

		// Write into the Linear record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 1, Appli4Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x4003, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

    // Read the Linear record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(0, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
    }

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

		// Write Cyclic record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 1, Appli4Key1, &sw);
		CHECK_RC();

		rc = SPROX_Desfire_IsoSelectEF(0x4004, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < 2 * AppliXFileXRecCo; bRecNo++)
		{
			for (wOffset=0; wOffset<AppliXFileXRecSz; wOffset++)
				abDataBuffer[wOffset] = (BYTE) ((bRecNo << 4) | wOffset);

			rc = SPROX_Desfire_IsoAppendRecord(abDataBuffer, AppliXFileXRecSz, &sw);
			CHECK_RC();
		}

    // Read the Cyclic record file

		rc = SPROX_Desfire_IsoMutualAuthenticate(DF_ISO_CIPHER_AES, DF_ISO_APPLICATION_KEY | 2, Appli4Key2, &sw);
		CHECK_RC();

		for (bRecNo = 0; bRecNo < AppliXFileXRecCo-1; bRecNo++)
		{
			rc = SPROX_Desfire_IsoReadRecord(bRecNo, FALSE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
			CHECK_RC();
		}

	  rc = SPROX_Desfire_IsoReadRecord(0, TRUE, abDataBuffer, sizeof(abDataBuffer), &wDataLength, &sw);
		CHECK_RC();

  }

  printf("\n");
  printf("All tests have been successfully passed\n");

  goto tag_stop;

 tag_stop:

  /* T=CL (ISO 14443-4) tag stop */
  /* --------------------------- */

  rc = SPROX_TclA_Deselect(card_identifier);
  if (rc != MI_OK)
  {
    printf("T=CL DESELECT failed (%d)\n", rc);
    goto tag_halt;
  }

tag_halt:

  /* ISO 14443-3 tag stop */
  /* -------------------- */

  rc = SPROX_TclA_Halt();
  if (rc != MI_OK)
  {
    printf("HALT failed\n");
    goto close;
  }

  /* Another tag in the field ? */
  /* -------------------------- */
  goto next_tag;

close:
  SPROX_ControlRF(FALSE);
  SPROX_ReaderClose();

done:
  /* Display last error */
  if (rc == MI_OK)
  {
    printf("Done\n");
  } else
  {
    printf("%s (%d)\n", SPROX_GetErrorMessage(rc), rc);
  }

  return 0;
}
